#import "WGAppDelegate.h"

@implementation WGAppDelegate

/*===================================
    初期化 
=====================================*/
- (id)init
{
    [ super init ];

    mDownloadingNum = 0;
    
    [ [ NSNotificationCenter defaultCenter ] addObserver : self 
						selector : @selector( nowStartDownload : ) 
						    name : kWGNowStartDownloadNotification 
						  object : nil ];
    [ [ NSNotificationCenter defaultCenter ] addObserver : self 
						selector : @selector( nowTerminateDownload: ) 
						    name : kWGNowTerminateDownloadNotification 
						  object : nil ];

    return self;
}

- (NSApplicationTerminateReply)applicationShouldTerminate : (NSApplication *)sender
{
    int		theAlertPanel;
    NSBundle*	theBundle = [ NSBundle mainBundle ];
    NSString*	theOKStr = [ theBundle localizedStringForKey : @"OK" value : @"OK" table : nil ];
    NSString*	theCancelStr = [ theBundle localizedStringForKey : @"Cancel" value : @"Cancel" table : nil ];
    NSString*	theNowDownloadingsWouldYouStopThemStr = [ theBundle localizedStringForKey : @"Now Downloading(s)...\nWould you stop it(them)?" value : @"Now Downloading(s)...\nWould you stop it(them)?" table : nil ];

    if ( mDownloadingNum ) {
	theAlertPanel = NSRunAlertPanel( @"wget+", theNowDownloadingsWouldYouStopThemStr, theOKStr, theCancelStr, nil );
	
	if ( NSAlertAlternateReturn == theAlertPanel ) {
	    return NSTerminateCancel;
	}
    }
    return NSTerminateNow;
}

- (void)nowStartDownload : (NSNotification *)inNotification
{
    mDownloadingNum++;
}
- (void)nowTerminateDownload : (NSNotification *)inNotification
{
    mDownloadingNum--;
}
@end
