/*
 *  WGPreferenceDefine.h
 *  wget+
 *
 *  Created by tomatsu on Wed Aug 08 2001.
 *  Copyright (c) 2001 Tomonori Tomatsu. All rights reserved.
 *
 */
/********************** State ***********************/
#define kWGStateTimeUnitDay 				@"d"
#define kWGStateTimeUnitHour 				@"h"
#define kWGStateTimeUnitMin 				@"m"
#define kWGStateTimeUnitSec 				@""
#define kWGStateButtonON 				YES
#define kWGStateButtonOFF 				NO
#define kWGStateMakeFolderDontMake 			@"DontMakeFolder"
#define kWGStateMakeFolderNormal 			@"MakeFolderNormal"
#define kWGStateMakeFolderAlways 			@"MakeFolderAlways"
#define kWGStateLogLevel1 				0
#define kWGStateLogLevel2 				25
#define kWGStateLogLevel3 				50
#define kWGStateLogLevel4 				75
#define kWGStateLogLevel5 				100
#define kWGStateLogStyle6K	 			@"micro"
#define kWGStateLogStyle50K	 			@"default"
#define kWGStateLogStyle384K	 			@"binary"
#define kWGStateLogStyle3M	 			@"mega"
#define kWGStateLogFileTypeOverwrite			@"LogFileTypeOverWrite"
#define kWGStateLogFileTypeAppend			@"LogFileTypeAppend"

/********************** Key ***********************/
// Version
#define kWGUserDefaultVersionKey 			@"WGUserDefaultVersionKey"
// Dictionary
#define kPreferenceDownloadDictionaryKey 		@"PreferenceDownloadDictionaryKey"
#define kPreferenceLogDictionaryKey 			@"PreferenceLogDictionaryKey"
#define kPreferenceOtherDictionaryKey 			@"PreferenceOtherDictionaryKey"
//Download
#define kPreference_d_RetryKey 				@"Preference_d_RetryKey"
#define kPreference_d_TimeOutNumKey 			@"Preference_d_TimeOutNumKey"
#define kPreference_d_TimeOutUnitKey 			@"Preference_d_TimeOutUnitKey"
#define kPreference_d_ContentLengthKey 			@"Preference_d_ContentLengthKey"
#define kPreference_d_WaitTimeKey 			@"Preference_d_WaitTimeKey"
#define kPreference_d_WaitTimeUnitKey 			@"Preference_d_WaitTimeUnitKey"
#define kPreference_d_UseServerCashKey 			@"Preference_d_UseServerCashKey"
#define kPreference_d_SaveLocationKey 			@"Preference_d_SaveLocationKey"
#define kPreference_d_MakeFolderKey 			@"Preference_d_MakeFolderKey"
#define kPreference_d_MakeFolderByHostNameKey 		@"Preference_d_MakeFolderByHostNameKey"
#define kPreference_d_OmitFolderKey 			@"Preference_d_OmitFolderKey"
// Log
#define kPreference_l_LogLevelKey 			@"Preference_l_LogLevelKey"
#define kPreference_l_LogStyleKey 			@"Preference_l_LogStyleKey"
#define kPreference_l_OutputLogFileKey 			@"Preference_l_OutputLogFileKey"
#define kPreference_l_OutputLogFileTypeKey 		@"Preference_l_OutputLogFileTypeKey"
#define kPreference_l_OutputLogFileLocationKey 		@"Preference_l_OutputLogFileLocationKey"
#define kPreference_l_LogFileCapacityKey 		@"Preference_l_LogFileCapacityKey"
// Other
#define kPreference_o_DNSLookUpKey 			@"Preference_o_DNSLookUpKey"
#define kPreference_o_OnlyCheakKey 			@"Preference_o_OnlyCheakKey"
#define kPreference_o_UsePassiveModeKey 		@"Preference_o_UsePassiveModeKey"
#define kPreference_o_UseProxyKey 			@"Preference_o_UseProxyKey"
#define kPreference_o_ProxyIPAdressKey 			@"Preference_o_ProxyIPAdressKey"
#define kPreference_o_ProxyPortKey 			@"Preference_o_ProxyPortKey"
#define kPreference_o_DontGetArrayKey 			@"Preference_o_DontGetArrayKey"

/********************* (Default) Value *************************/
// Version
#define kDefaultWGUserDefaultVersionValue		[ NSNumber numberWithFloat : 0.1 ]
//Download
#define kDefaultPreference_d_RetryValue			20
#define kDefaultPreference_d_TimeOutNumValue		15
#define kDefaultPreference_d_TimeOutUnitValue		kWGStateTimeUnitMin
#define kDefaultPreference_d_ContentLengthValue		kWGStateButtonON
#define kDefaultPreference_d_WaitTimeValue		0
#define kDefaultPreference_d_WaitTimeUnitValue		kWGStateTimeUnitSec
#define kDefaultPreference_d_UseServerCashValue		kWGStateButtonON
#define kDefaultPreference_d_SaveLocationValue		NSHomeDirectory()
#define kDefaultPreference_d_MakeFolderValue		kWGStateMakeFolderNormal
#define kDefaultPreference_d_MakeFolderByHostNameValue	kWGStateButtonON
#define kDefaultPreference_d_OmitFolderValue		0
// Log
#define kDefaultPreference_l_LogLevelValue 		50
#define kDefaultPreference_l_LogStyleValue 		kWGStateLogStyle50K
#define kDefaultPreference_l_OutputLogFileValue 	kWGStateButtonOFF
#define kDefaultPreference_l_OutputLogFileTypeValue 	kWGStateLogFileTypeOverwrite
#define kDefaultPreference_l_OutputLogFileLocationValue NSHomeDirectory()
#define kDefaultPreference_l_LogFileCapacityValue 	1
// Other
#define kDefaultPreference_o_DNSLookUpValue 		kWGStateButtonOFF
#define kDefaultPreference_o_OnlyCheakValue 		kWGStateButtonOFF
#define kDefaultPreference_o_UsePassiveModeValue 	kWGStateButtonOFF
#define kDefaultPreference_o_UseProxyValue 		kWGStateButtonOFF
#define kDefaultPreference_o_ProxyIPAdressValue 	@""
#define kDefaultPreference_o_ProxyPortValue 		@""
#define kDefaultPreference_o_DontGetArrayValue 		[ NSMutableArray array ]

/********************* Args *************************/
#define kWGOptionON					@"on"
#define kWGOptionOFF					@"off"
#define kLogFileName					@"wget+.log"
#define kWGOptionExecute				@"--execute"	// R[h̊֌W炩HA󔒂܂߂鎖oȂׁB 

#define kWGRetryOption					@"-t"
#define kWGTimeOutOption				@"-T"
#define kWGIgnoreLengthOption				@"--ignore-length"
#define kWGWaitTimeOption				@"-w"
#define kWGUseServerCasheOption				@"--cache"
#define kWGSaveLocationOption				@"-P"
#define kWGNoDirectoriesOption				@"-nd"
#define kWGForceMakeDirectoriesOption			@"-x"
#define kWGDontMakeHostNameFolderOption			@"-nH"
#define kWGOmitMakingFolderOption			@"--cut-dirs"
#define kWGQuietLogOption				@"-q"
#define kWGNoVerbaseLogOption				@"-nv"
#define kWGDebugLogOption				@"-d"
#define kWGServerResponseLogOption			@"-S"
#define kWGLogStyleOption				@"--dot-style"
#define kWGLogOverwriteOption				@"-o"
#define kWGLogAppendOption				@"-a"
#define kWGDontLookUpDNSOption				@"-nh"
#define kWGOnlyCheakOption				@"--spider"
#define kWGFTPPassiveModeOption				@"--passive-ftp"
#define kWGUseProxyOption				@"--proxy"
#define kWGHTTPProxyOption				@"http_proxy"


