#import <Cocoa/Cocoa.h>
#import "WGPreferenceProtocol.h"
#import "WGPreferenceDefine.h"

@interface WGPreferenceDownloadController : NSObject <WGPreferenceController>
{
    IBOutlet id WGPreferenceInstance;
    IBOutlet id _d_ContentLength;
    IBOutlet id _d_MakeFolder;
    IBOutlet id _d_MakeFolderByHostName;
    IBOutlet id _d_MakeFolderTitle;
    IBOutlet id _d_OmitFolderNum;
    IBOutlet id _d_OmitFolderTitle;
    IBOutlet id _d_OmitFolderUnit;
    IBOutlet id _d_RetryNum;
    IBOutlet id _d_RetryNumTitle;
    IBOutlet id _d_RetryUnit;
    IBOutlet id _d_SaveLocation;
    IBOutlet id _d_SaveOpen;
    IBOutlet id _d_SaveTitle;
    IBOutlet id _d_SeparateLine;
    IBOutlet id _d_ServerCash;
    IBOutlet id _d_TimeOutNum;
    IBOutlet id _d_TimeOutTitle;
    IBOutlet id _d_TimeOutUnit;
    IBOutlet id _d_WaitTimeNum;
    IBOutlet id _d_WaitTimeTitle;
    IBOutlet id _d_WaitTimeUnit;
    
    BOOL		mContentLengthRButtonState;
    NSMutableString*	mMakeFolderMenuState;
    BOOL		mMakeHostNameFolderRButtonState;
    int			mOmitFolderTextEditState;
    int			mRetryTextEditState;
    NSMutableString*	mSaveLocationTextEdit;
    int			mTimeOutTextEditState;
    NSMutableString*	mTimeOutUnitMenuState;
    BOOL		mUseServerCashRButtonState;
    int			mWaitTimeTextEditState;
    NSMutableString*	mWaitTimeUnitMenuState;

    BOOL		mSavedContentLengthRButtonState;
    NSMutableString*	mSavedMakeFolderMenuState;
    BOOL		mSavedMakeHostNameFolderRButtonState;
    int			mSavedOmitFolderTextEditState;
    int			mSavedRetryTextEditState;
    NSMutableString*	mSavedSaveLocationTextEdit;
    int			mSavedTimeOutTextEditState;
    NSMutableString*	mSavedTimeOutUnitMenuState;
    BOOL		mSavedUseServerCashRButtonState;
    int			mSavedWaitTimeTextEditState;
    NSMutableString*	mSavedWaitTimeUnitMenuState;

    long		mChangeValueFlag;
#define	kChangeContentLength		0x00000001
#define	kChangeMakeFolderMenu		0x00000002
#define	kChangeMakeHostNameFolder	0x00000004
#define	kChangeOmitFolder		0x00000008
#define	kChangeRetry			0x00000010
#define	kChangeSaveLocation		0x00000020
#define	kChangeTimeOut			0x00000040
#define	kChangeTimeOutUnit		0x00000080
#define	kChangeUseServerCash		0x00000100
#define	kChangeWaitTime			0x00000200
#define	kChangeWaitTimeUnit		0x00000400
}

- (id)init;
- (void)dealloc;

- (IBAction)hitContentLengthRButton:(id)sender;
- (IBAction)hitMakeFolderMenu:(id)sender;
- (IBAction)hitMakeHostNameFolderRButton:(id)sender;
- (IBAction)hitOmitFolderTextEdit:(id)sender;
- (IBAction)hitRetryTextEdit:(id)sender;
- (IBAction)hitSaveLocationTextEdit:(id)sender;
- (IBAction)hitTimeOutTextEdit:(id)sender;
- (IBAction)hitTimeOutUnitMenu:(id)sender;
- (IBAction)hitUseServerCashRButton:(id)sender;
- (IBAction)hitWaitTimeTextEdit:(id)sender;
- (IBAction)hitWaitTimeUnitMenu:(id)sender;

- (IBAction)hitSaveLocationOpenButton:(id)sender;
- (void)saveLocationOpenPanelDidEnd : (NSOpenPanel *)sheet returnCode : (int)returnCode contextInfo : (void *)contextInfo;

// Ǐ\bh 
- (void)anyItemHit;

@end
