#import "WGPreferenceDownloadController.h"

@implementation WGPreferenceDownloadController
/*===================================
     
=====================================*/
- (id)init
{
    [ super init ];

    mChangeValueFlag = 0;

    mContentLengthRButtonState = kWGStateButtonON;
    mMakeFolderMenuState = [ [ NSMutableString alloc ] init ];
    mMakeHostNameFolderRButtonState = kWGStateButtonON;
    mOmitFolderTextEditState = kDefaultPreference_d_OmitFolderValue;
    mRetryTextEditState = kDefaultPreference_d_RetryValue;
    mSaveLocationTextEdit = [ [ NSMutableString alloc ] init ];
    mTimeOutTextEditState = kDefaultPreference_d_TimeOutNumValue;
    mTimeOutUnitMenuState = [ [ NSMutableString alloc ] init ];
    mUseServerCashRButtonState = kWGStateButtonON;
    mWaitTimeTextEditState = kDefaultPreference_d_WaitTimeValue;
    mWaitTimeUnitMenuState = [ [ NSMutableString alloc ] init ];

    mSavedContentLengthRButtonState = kWGStateButtonON;
    mSavedMakeFolderMenuState = [ [ NSMutableString alloc ] init ];
    mSavedMakeHostNameFolderRButtonState = kWGStateButtonON;
    mSavedOmitFolderTextEditState = kDefaultPreference_d_OmitFolderValue;
    mSavedRetryTextEditState = kDefaultPreference_d_RetryValue;
    mSavedSaveLocationTextEdit = [ [ NSMutableString alloc ] init ];
    mSavedTimeOutTextEditState = kDefaultPreference_d_TimeOutNumValue;
    mTimeOutUnitMenuState = [ [ NSMutableString alloc ] init ];
    mSavedUseServerCashRButtonState = kWGStateButtonON;
    mSavedWaitTimeTextEditState = kDefaultPreference_d_WaitTimeValue;
    mSavedWaitTimeUnitMenuState = [ [ NSMutableString alloc ] init ];

    return self;
}

/*===================================
    dealloc 
=====================================*/
- (void)dealloc
{
    [ mMakeFolderMenuState release ];
    [ mSaveLocationTextEdit release ];
    [ mTimeOutUnitMenuState release ];
    [ mWaitTimeUnitMenuState release ];
    [ mSavedMakeFolderMenuState release ];
    [ mSavedSaveLocationTextEdit release ];
    [ mSavedTimeOutUnitMenuState release ];
    [ mSavedWaitTimeUnitMenuState release ];
    
    [ super dealloc ];
}

/*===================================
    GUI\̏ 
=====================================*/
- (void)initValuesWithDictionary : (NSMutableDictionary*)values
{
    mChangeValueFlag = 0;
    mSavedContentLengthRButtonState = [ [ values objectForKey : kPreference_d_ContentLengthKey ] boolValue ];
    [ mSavedMakeFolderMenuState setString : [ values objectForKey : kPreference_d_MakeFolderKey ] ];
    mSavedMakeHostNameFolderRButtonState = [ [ values objectForKey : kPreference_d_MakeFolderByHostNameKey ] boolValue ];
    mSavedOmitFolderTextEditState = [ [ values objectForKey : kPreference_d_OmitFolderKey ] intValue ];
    mSavedRetryTextEditState = [ [ values objectForKey : kPreference_d_RetryKey ] intValue ];
    [ mSavedSaveLocationTextEdit setString : [ values objectForKey : kPreference_d_SaveLocationKey ] ];
    mSavedTimeOutTextEditState = [ [ values objectForKey : kPreference_d_TimeOutNumKey ] intValue ];
    [ mSavedTimeOutUnitMenuState setString : [ values objectForKey : kPreference_d_TimeOutUnitKey ] ];
    mSavedUseServerCashRButtonState = [ [ values objectForKey : kPreference_d_UseServerCashKey ] boolValue ];
    mSavedWaitTimeTextEditState = [ [ values objectForKey : kPreference_d_WaitTimeKey ] intValue ];
    [ mSavedWaitTimeUnitMenuState setString : [ values objectForKey : kPreference_d_WaitTimeUnitKey ] ];

    [ self setValuesWithDictionary : values ];
}

/*===================================
    GUIɐݒ肷  
=====================================*/
- (void)setValuesWithDictionary : values
{
    mContentLengthRButtonState = [ [ values objectForKey : kPreference_d_ContentLengthKey ] boolValue ];
    [ mMakeFolderMenuState setString : [ values objectForKey : kPreference_d_MakeFolderKey ] ];
    mMakeHostNameFolderRButtonState = [ [ values objectForKey : kPreference_d_MakeFolderByHostNameKey ] boolValue ];
    mOmitFolderTextEditState = [ [ values objectForKey : kPreference_d_OmitFolderKey ] intValue ];
    mRetryTextEditState = [ [ values objectForKey : kPreference_d_RetryKey ] intValue ];
    [ mSaveLocationTextEdit setString : [ values objectForKey : kPreference_d_SaveLocationKey ] ];
    mTimeOutTextEditState = [ [ values objectForKey : kPreference_d_TimeOutNumKey ] intValue ];
    [ mTimeOutUnitMenuState setString : [ values objectForKey : kPreference_d_TimeOutUnitKey ] ];
    mUseServerCashRButtonState = [ [ values objectForKey : kPreference_d_UseServerCashKey ] boolValue ];
    mWaitTimeTextEditState = [ [ values objectForKey : kPreference_d_WaitTimeKey ] intValue ];
    [ mWaitTimeUnitMenuState setString : [ values objectForKey : kPreference_d_WaitTimeUnitKey ] ];

    // UContent-Lengthɂ閳_E[hh~ 
    if ( kWGStateButtonON == mContentLengthRButtonState ) {
	[ _d_ContentLength setState : NSOnState ];
    } else {
	[ _d_ContentLength setState : NSOffState ];
    }
    // tH_쐬 
    if ( [ mMakeFolderMenuState isEqualToString : kWGStateMakeFolderDontMake ] ) {
	[ _d_MakeFolder selectItemAtIndex : 0 ];
    } else if ( [ mMakeFolderMenuState isEqualToString : kWGStateMakeFolderNormal ] ) {
	[ _d_MakeFolder selectItemAtIndex : 1 ];
    } else if ( [ mMakeFolderMenuState isEqualToString : kWGStateMakeFolderAlways ] ) {
	[ _d_MakeFolder selectItemAtIndex : 2 ];
    }
    // zXgɂtH_쐬 
    if ( kWGStateButtonON == mMakeHostNameFolderRButtonState ) {
	[ _d_MakeFolderByHostName setState : NSOnState ];
    } else {
	[ _d_MakeFolderByHostName setState : NSOffState ];
    }
    // tH_쐬ȗ 
    [ _d_OmitFolderNum setIntValue : mOmitFolderTextEditState ];
    // gC 
    [ _d_RetryNum setIntValue : mRetryTextEditState ];
    // ۑ 
    [ _d_SaveLocation setStringValue : mSaveLocationTextEdit ];
    // ^CAEg 
    [ _d_TimeOutNum setIntValue : mTimeOutTextEditState ];
    // ^CAEgP  
    if ( [ mTimeOutUnitMenuState isEqualToString : kWGStateTimeUnitSec ] ) {
	[ _d_TimeOutUnit selectItemAtIndex : 0 ];
    } else if ( [ mTimeOutUnitMenuState isEqualToString : kWGStateTimeUnitMin ] ) {
	[ _d_TimeOutUnit selectItemAtIndex : 1 ];
    } else if ( [ mTimeOutUnitMenuState isEqualToString : kWGStateTimeUnitHour ] ) {
	[ _d_TimeOutUnit selectItemAtIndex : 2 ];
    } else if ( [ mTimeOutUnitMenuState isEqualToString : kWGStateTimeUnitDay ] ) {
	[ _d_TimeOutUnit selectItemAtIndex : 3 ];
    }
    // T[õLbV𗘗p 
    if ( kWGStateButtonON == mUseServerCashRButtonState ) {
	[ _d_ServerCash setState : NSOnState ];
    } else {
	[ _d_ServerCash setState : NSOffState ];
    }
    // t@CJn܂ł̑҂ 
    [ _d_WaitTimeNum setIntValue : mWaitTimeTextEditState ];
    // t@CJn܂ł̑҂ԒP 
    if ( [ mWaitTimeUnitMenuState isEqualToString : kWGStateTimeUnitSec ] ) {
	[ _d_WaitTimeUnit selectItemAtIndex : 0 ];
    } else if ( [ mWaitTimeUnitMenuState isEqualToString : kWGStateTimeUnitMin ] ) {
	[ _d_WaitTimeUnit selectItemAtIndex : 1 ];
    } else if ( [ mWaitTimeUnitMenuState isEqualToString : kWGStateTimeUnitHour ] ) {
	[ _d_WaitTimeUnit selectItemAtIndex : 2 ];
    } else if ( [ mWaitTimeUnitMenuState isEqualToString : kWGStateTimeUnitDay ] ) {
	[ _d_WaitTimeUnit selectItemAtIndex : 3 ];
    }
}

/*===================================
    LZꂽ̃Zbg   
=====================================*/
- (void)resetValuesWithDictionary : (NSMutableDictionary*)values
{
    mChangeValueFlag = 0;
    [ self setValuesWithDictionary : values ];
} 

/*===================================
    ̐ݒԂ    
=====================================*/
- (NSDictionary*)dictionaryValues
{
    NSDictionary*	theReturn;
    theReturn = [ [ NSDictionary alloc ] initWithObjectsAndKeys : 
			    [ NSNumber numberWithInt : mRetryTextEditState ], kPreference_d_RetryKey,
			    [ NSNumber numberWithInt : mTimeOutTextEditState ], kPreference_d_TimeOutNumKey,
			    mTimeOutUnitMenuState, kPreference_d_TimeOutUnitKey,
			    [ NSNumber numberWithBool : mContentLengthRButtonState ], kPreference_d_ContentLengthKey,
			    [ NSNumber numberWithInt : mWaitTimeTextEditState ], kPreference_d_WaitTimeKey,
			    mWaitTimeUnitMenuState, kPreference_d_WaitTimeUnitKey,
			    [ NSNumber numberWithBool : mUseServerCashRButtonState ], kPreference_d_UseServerCashKey,
			    mSaveLocationTextEdit, kPreference_d_SaveLocationKey,
			    mMakeFolderMenuState, kPreference_d_MakeFolderKey,
			    [ NSNumber numberWithBool : mMakeHostNameFolderRButtonState ], kPreference_d_MakeFolderByHostNameKey,
			    [ NSNumber numberWithInt : mOmitFolderTextEditState ], kPreference_d_OmitFolderKey,
			    nil ];

    return theReturn;
}

/*===================================
    hitContentLengthRButton     
=====================================*/
- (IBAction)hitContentLengthRButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mContentLengthRButtonState = kWGStateButtonON;
    } else {
	mContentLengthRButtonState = kWGStateButtonOFF;
    }
    
    if ( mContentLengthRButtonState == mSavedContentLengthRButtonState  ) {
	mChangeValueFlag &= ~kChangeContentLength;
    } else {
	mChangeValueFlag |= kChangeContentLength;
    }
    
    [ self anyItemHit ];
}

/*===================================
    hitUseServerCashRButton     
=====================================*/
- (IBAction)hitMakeFolderMenu:(id)sender
{
    if ( 0 == [ sender indexOfSelectedItem ] ) {
	[ mMakeFolderMenuState setString : kWGStateMakeFolderDontMake ];
    } else if ( 1 == [ sender indexOfSelectedItem ] ) {
	[ mMakeFolderMenuState setString : kWGStateMakeFolderNormal ];
    } else if ( 2 == [ sender indexOfSelectedItem ]) {
	[ mMakeFolderMenuState setString : kWGStateMakeFolderAlways ];
    }

    if ( [ mMakeFolderMenuState isEqualToString : mSavedMakeFolderMenuState ] ) {
	mChangeValueFlag &= ~kChangeMakeFolderMenu;
    } else {
	mChangeValueFlag |= kChangeMakeFolderMenu;
    }

    [ self anyItemHit ];
}

/*===================================
    hitMakeHostNameFolderRButton     
=====================================*/
- (IBAction)hitMakeHostNameFolderRButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mMakeHostNameFolderRButtonState = kWGStateButtonON;
    } else {
	mMakeHostNameFolderRButtonState = kWGStateButtonOFF;
    }
    
    if ( mMakeHostNameFolderRButtonState == mSavedMakeHostNameFolderRButtonState  ) {
	mChangeValueFlag &= ~kChangeMakeHostNameFolder;
    } else {
	mChangeValueFlag |= kChangeMakeHostNameFolder;
    }

    [ self anyItemHit ];
}

/*===================================
    hitOmitFolderTextEdit     
=====================================*/
- (IBAction)hitOmitFolderTextEdit:(id)sender
{
    mOmitFolderTextEditState = [ sender intValue ];

    if ( mOmitFolderTextEditState == mSavedOmitFolderTextEditState  ) {
	mChangeValueFlag &= ~kChangeOmitFolder;
    } else {
	mChangeValueFlag |= kChangeOmitFolder;
    }

    [ self anyItemHit ];
}

/*===================================
    hitRetryTextEdit     
=====================================*/
- (IBAction)hitRetryTextEdit:(id)sender
{
    mRetryTextEditState = [ sender intValue ];

    if ( mRetryTextEditState == mSavedRetryTextEditState  ) {
	mChangeValueFlag &= ~kChangeRetry;
    } else {
	mChangeValueFlag |= kChangeRetry;
    }

    [ self anyItemHit ];
}

/*===================================
    hitSaveLocationTextEdit     
=====================================*/
- (IBAction)hitSaveLocationTextEdit:(id)sender
{
    [ mSaveLocationTextEdit setString : [ sender stringValue ] ];

    if ( [ mSaveLocationTextEdit isEqualToString : mSavedSaveLocationTextEdit ] ) {
	mChangeValueFlag &= ~kChangeSaveLocation;
    } else {
	mChangeValueFlag |= kChangeSaveLocation;
    }

    [ self anyItemHit ];
}

/*===================================
    hitTimeOutTextEdit     
=====================================*/
- (IBAction)hitTimeOutTextEdit:(id)sender
{
    mTimeOutTextEditState = [ sender intValue ];

    if ( mTimeOutTextEditState == mSavedTimeOutTextEditState  ) {
	mChangeValueFlag &= ~kChangeTimeOut;
    } else {
	mChangeValueFlag |= kChangeTimeOut;
    }

    [ self anyItemHit ];
}

/*===================================
    hitTimeOutUnitMenu     
=====================================*/
- (IBAction)hitTimeOutUnitMenu:(id)sender
{
    if ( 0 == [ sender indexOfSelectedItem ] ) {
	[ mTimeOutUnitMenuState setString : kWGStateTimeUnitSec ];
    } else if ( 1 == [ sender indexOfSelectedItem ] ) {
	[ mTimeOutUnitMenuState setString : kWGStateTimeUnitMin ];
    } else if ( 2 == [ sender indexOfSelectedItem ]) {
	[ mTimeOutUnitMenuState setString : kWGStateTimeUnitHour ];
    } else if ( 3 == [ sender indexOfSelectedItem ]) {
	[ mTimeOutUnitMenuState setString : kWGStateTimeUnitDay ];
    }

    if ( [ mTimeOutUnitMenuState isEqualToString : mSavedTimeOutUnitMenuState ] ) {
	mChangeValueFlag &= ~kChangeTimeOutUnit;
    } else {
	mChangeValueFlag |= kChangeTimeOutUnit;
    }

    [ self anyItemHit ];
}

/*===================================
    hitUseServerCashRButton     
=====================================*/
- (IBAction)hitUseServerCashRButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mUseServerCashRButtonState = kWGStateButtonON;
    } else {
	mUseServerCashRButtonState = kWGStateButtonOFF;
    }
    
    if ( mUseServerCashRButtonState == mSavedUseServerCashRButtonState  ) {
	mChangeValueFlag &= ~kChangeUseServerCash;
    } else {
	mChangeValueFlag |= kChangeUseServerCash;
    }

    [ self anyItemHit ];
}

/*===================================
    hitWaitTimeTextEdit     
=====================================*/
- (IBAction)hitWaitTimeTextEdit:(id)sender
{
    mWaitTimeTextEditState = [ sender intValue ];

    if ( mWaitTimeTextEditState == mSavedWaitTimeTextEditState  ) {
	mChangeValueFlag &= ~kChangeWaitTime;
    } else {
	mChangeValueFlag |= kChangeWaitTime;
    }

    [ self anyItemHit ];
}

/*===================================
    hitWaitTimeUnitMenu     
=====================================*/
- (IBAction)hitWaitTimeUnitMenu:(id)sender
{
    if ( 0 == [ sender indexOfSelectedItem ] ) {
	[ mWaitTimeUnitMenuState setString : kWGStateTimeUnitSec ];
    } else if ( 1 == [ sender indexOfSelectedItem ] ) {
	[ mWaitTimeUnitMenuState setString : kWGStateTimeUnitMin ];
    } else if ( 2 == [ sender indexOfSelectedItem ]) {
	[ mWaitTimeUnitMenuState setString : kWGStateTimeUnitHour ];
    } else if ( 3 == [ sender indexOfSelectedItem ]) {
	[ mWaitTimeUnitMenuState setString : kWGStateTimeUnitDay ];
    }

    if ( [ mWaitTimeUnitMenuState isEqualToString : mSavedWaitTimeUnitMenuState ] ) {
	mChangeValueFlag &= ~kChangeWaitTimeUnit;
    } else {
	mChangeValueFlag |= kChangeWaitTimeUnit;
    }

    [ self anyItemHit ];
}

/*===================================
    anyItemHit     
=====================================*/
- (void)anyItemHit
{
    if ( mChangeValueFlag ) [ WGPreferenceInstance changeValue : self ];
    else [ WGPreferenceInstance unchangeValue : self ];
}

/*===================================
    hitSaveLocationOpenButton     
=====================================*/
- (IBAction)hitSaveLocationOpenButton:(id)sender
{
    NSOpenPanel*	thePanel = [ NSOpenPanel openPanel ];
    
    [ thePanel setCanChooseDirectories : YES ];
    [ thePanel setCanChooseFiles : NO ];
    [ thePanel setAllowsMultipleSelection : NO ];
    [ thePanel beginSheetForDirectory : NSHomeDirectory()
				 file : nil
				types : nil
		       modalForWindow : [ NSApp keyWindow ]
			modalDelegate : self
		       didEndSelector : @selector( saveLocationOpenPanelDidEnd : returnCode : contextInfo : )
			  contextInfo : nil ];
	 
}

/*===================================
    saveLocationOpenPanelDidEnd hitSaveLocationOpenButtondidEndSheet     
=====================================*/
- (void)saveLocationOpenPanelDidEnd : (NSOpenPanel *)sheet returnCode : (int)returnCode contextInfo : (void *)contextInfo
{
    NSArray*	theFilesToOpen;
    NSString* 	theFileName;
    
    if ( returnCode == NSOKButton ) {
        theFilesToOpen = [ sheet filenames ];
	theFileName = [ theFilesToOpen objectAtIndex : 0 ];
	
	[ _d_SaveLocation setStringValue : theFileName ];
	[ self hitSaveLocationTextEdit : _d_SaveLocation ];
    }
}

@end
