#import "WGPreferenceLogController.h"

@implementation WGPreferenceLogController
/*===================================
     
=====================================*/
- (id)init
{
    [ super init ];
    
    mChangeValueFlag = 0;

    mLogLevelSliderState = kDefaultPreference_l_LogLevelValue;
    mLogStyleSliderState = [ [ NSMutableString alloc ] init ];
    mOutputLogFileCButtonState = kWGStateButtonOFF;
    mLogFileTypeRButtonGroupState = [ [ NSMutableString alloc ] init ];
    mLogFileOverwriteRButtonState = kWGStateButtonOFF;
    mLogFileAppendRButtonState = kWGStateButtonON;
    mLogFileSaveLocationTextEditState = [ [ NSMutableString alloc ] init ];
    mLogFileCapacityTextEditState = kDefaultPreference_l_LogFileCapacityValue;

    mSavedLogLevelSliderState = kDefaultPreference_l_LogLevelValue;
    mSavedLogStyleSliderState = [ [ NSMutableString alloc ] init ];
    mSavedOutputLogFileCButtonState = kWGStateButtonOFF;
    mSavedLogFileTypeRButtonGroupState = [ [ NSMutableString alloc ] init ];
    mSavedLogFileOverwriteRButtonState = kWGStateButtonOFF;
    mSavedLogFileAppendRButtonState = kWGStateButtonON;
    mSavedLogFileSaveLocationTextEditState = [ [ NSMutableString alloc ] init ];
    mSavedLogFileCapacityTextEditState = kDefaultPreference_l_LogFileCapacityValue;

    return self;
}

/*===================================
    dealloc 
=====================================*/
- (void)dealloc
{
    [ mLogStyleSliderState release ];
    [ mLogFileTypeRButtonGroupState release ];
    [ mLogFileSaveLocationTextEditState release ];
    [ mSavedLogStyleSliderState release ];
    [ mSavedLogFileTypeRButtonGroupState release ];
    [ mSavedLogFileSaveLocationTextEditState release ];
    
    [ super dealloc ];
}

/*===================================
    GUI\̏ 
=====================================*/
- (void)initValuesWithDictionary : (NSMutableDictionary*)values
{
    mChangeValueFlag = 0;

    mSavedLogLevelSliderState =  [ [ values objectForKey : kPreference_l_LogLevelKey ] intValue ];
    [ mSavedLogStyleSliderState setString : [ values objectForKey : kPreference_l_LogStyleKey ] ];
    mSavedOutputLogFileCButtonState = [ [ values objectForKey : kPreference_l_OutputLogFileKey ] boolValue ];
    [ mSavedLogFileTypeRButtonGroupState setString : [ values objectForKey : kPreference_l_OutputLogFileTypeKey ] ];
    if ( [ mSavedLogFileTypeRButtonGroupState isEqualToString : kWGStateLogFileTypeOverwrite ] ) {
	mSavedLogFileOverwriteRButtonState = kWGStateButtonON;
	mSavedLogFileAppendRButtonState = kWGStateButtonOFF;
    } else {
	mSavedLogFileOverwriteRButtonState = kWGStateButtonOFF;
	mSavedLogFileAppendRButtonState = kWGStateButtonON;
    }
    [ mSavedLogFileSaveLocationTextEditState setString : [ values objectForKey : kPreference_l_OutputLogFileLocationKey ] ];
    mSavedLogFileCapacityTextEditState = [ [ values objectForKey : kPreference_l_LogFileCapacityKey ] intValue ];

    [ self setValuesWithDictionary : values ];
}

/*===================================
    GUIɐݒ肷  
=====================================*/
- (void)setValuesWithDictionary : values
{
    mLogLevelSliderState =  [ [ values objectForKey : kPreference_l_LogLevelKey ] intValue ];
    [ mLogStyleSliderState setString : [ values objectForKey : kPreference_l_LogStyleKey ] ];
    mOutputLogFileCButtonState = [ [ values objectForKey : kPreference_l_OutputLogFileKey ] boolValue ];
    [ mLogFileTypeRButtonGroupState setString : [ values objectForKey : kPreference_l_OutputLogFileTypeKey ] ];
    if ( [ mLogFileTypeRButtonGroupState isEqualToString : kWGStateLogFileTypeOverwrite ] ) {
	mLogFileOverwriteRButtonState = YES;
	mLogFileAppendRButtonState = NO;
    } else {
	mLogFileOverwriteRButtonState = NO;
	mLogFileAppendRButtonState = YES;
    }
    [ mLogFileSaveLocationTextEditState setString : [ values objectForKey : kPreference_l_OutputLogFileLocationKey ] ];
    mLogFileCapacityTextEditState = [ [ values objectForKey : kPreference_l_LogFileCapacityKey ] intValue ];

    // Õx 
    [ _l_LogLevel setIntValue : mLogLevelSliderState ];
    // ÕX^C 
    if ( [ mLogStyleSliderState isEqualToString : kWGStateLogStyle6K ] ) {
	[ _l_LogDotStyle setIntValue : 0 ];
    } else if ( [ mLogStyleSliderState isEqualToString : kWGStateLogStyle50K ] ) {
	[ _l_LogDotStyle setIntValue : 33 ];
    } else if ( [ mLogStyleSliderState isEqualToString : kWGStateLogStyle384K ] ) {
	[ _l_LogDotStyle setIntValue : 66 ];
    } else {
	[ _l_LogDotStyle setIntValue : 100 ];
    }
    // Ot@Cɏo͂  
    if ( kWGStateButtonON == mOutputLogFileCButtonState ) {
	[ _l_MakeLogFile setState : NSOnState ];
    } else {
	[ _l_MakeLogFile setState : NSOffState ];
    }
    // Ot@Č` 
    if ( [ mLogFileTypeRButtonGroupState isEqualToString : kWGStateLogFileTypeOverwrite ] ) {
	[ _l_OverwriteLogFile setState : NSOnState ];
	[ _l_AppendLogFile setState : NSOffState ];
    } else {
	[ _l_OverwriteLogFile setState : NSOffState ];
	[ _l_AppendLogFile setState : NSOnState ];
    }
    // Oۑ 
    [ _l_LogFileOutputLocation setStringValue : mLogFileSaveLocationTextEditState ];
    // ÕLpVeB  
    [ _l_logFileCapacityNum setIntValue : mLogFileCapacityTextEditState ];
}

/*===================================
    LZꂽ̃Zbg   
=====================================*/
- (void)resetValuesWithDictionary : (NSMutableDictionary*)values
{
    mChangeValueFlag = 0;
    [ self setValuesWithDictionary : values ];
} 

/*===================================
    ̐ݒԂ    
=====================================*/
- (NSDictionary*)dictionaryValues
{
    NSDictionary*	theReturn;
    theReturn = [ [ NSDictionary alloc ] initWithObjectsAndKeys : 
			[ NSNumber numberWithInt : mLogLevelSliderState ], kPreference_l_LogLevelKey,
			mLogStyleSliderState, kPreference_l_LogStyleKey,
			[ NSNumber numberWithBool : mOutputLogFileCButtonState ], kPreference_l_OutputLogFileKey,
			mLogFileTypeRButtonGroupState, kPreference_l_OutputLogFileTypeKey,
			mLogFileSaveLocationTextEditState, kPreference_l_OutputLogFileLocationKey,
			[ NSNumber numberWithInt : mLogFileCapacityTextEditState ], kPreference_l_LogFileCapacityKey,
			nil ];
    return theReturn;
}

/*===================================
    hitLogFileAppendRButton     
=====================================*/
- (IBAction)hitLogFileAppendRButton:(id)sender
{
    if ( [ _l_AppendLogFile state] == NSOnState ) {
	mLogFileAppendRButtonState = kWGStateButtonON;
	mLogFileOverwriteRButtonState = kWGStateButtonOFF;
	[ mLogFileTypeRButtonGroupState setString : kWGStateLogFileTypeAppend ];
    } else {
	mLogFileAppendRButtonState = kWGStateButtonOFF;
	mLogFileOverwriteRButtonState = kWGStateButtonON;
 	[ mLogFileTypeRButtonGroupState setString : kWGStateLogFileTypeOverwrite ];
   }
    
    if ( mLogFileAppendRButtonState == mSavedLogFileAppendRButtonState  ) {
	mChangeValueFlag ^= kChangeLogFileAppend;
    } else {
	mChangeValueFlag |= kChangeLogFileAppend;
    }
    
    if ( mLogFileOverwriteRButtonState == mSavedLogFileAppendRButtonState  ) {
	mChangeValueFlag ^= kChangeLogFileOverwrite;
    } else {
	mChangeValueFlag |= kChangeLogFileOverwrite;
    }
    
    [ self anyItemHit ];
}

/*===================================
    hitLogFileCapacityTextEdit     
=====================================*/
- (IBAction)hitLogFileCapacityTextEdit:(id)sender
{
    mLogFileCapacityTextEditState = [ sender intValue ];

    if ( mLogFileCapacityTextEditState == mSavedLogFileCapacityTextEditState  ) {
	mChangeValueFlag &= ~kChangeLogFileCapacity;
    } else {
	mChangeValueFlag |= kChangeLogFileCapacity;
    }

    [ self anyItemHit ];
}

/*===================================
    hitLogFileOverwriteRButton     
=====================================*/
- (IBAction)hitLogFileOverwriteRButton:(id)sender
{
    if ( [ _l_OverwriteLogFile state] == NSOnState ) {
	mLogFileOverwriteRButtonState = kWGStateButtonON;
	mLogFileAppendRButtonState = kWGStateButtonOFF;
	[ mLogFileTypeRButtonGroupState setString : kWGStateLogFileTypeOverwrite ];
    } else {
	mLogFileOverwriteRButtonState = kWGStateButtonOFF;
	mLogFileAppendRButtonState = kWGStateButtonON;
 	[ mLogFileTypeRButtonGroupState setString : kWGStateLogFileTypeAppend ];
   }
    
    if ( mLogFileOverwriteRButtonState == mSavedLogFileAppendRButtonState  ) {
	mChangeValueFlag ^= kChangeLogFileOverwrite;
    } else {
	mChangeValueFlag |= kChangeLogFileOverwrite;
    }
    
    if ( mLogFileAppendRButtonState == mSavedLogFileAppendRButtonState  ) {
	mChangeValueFlag ^= kChangeLogFileAppend;
    } else {
	mChangeValueFlag |= kChangeLogFileAppend;
    }
    
    [ self anyItemHit ];
}

/*===================================
    hitLogFileSaveLocationTextEdit     
=====================================*/
- (IBAction)hitLogFileSaveLocationTextEdit:(id)sender
{
    [ mLogFileSaveLocationTextEditState setString : [ sender stringValue ] ];

    if ( [ mLogFileSaveLocationTextEditState isEqualToString : mSavedLogFileSaveLocationTextEditState ] ) {
	mChangeValueFlag &= ~kChangeLogFileSaveLocation;
    } else {
	mChangeValueFlag |= kChangeLogFileSaveLocation;
    }

    [ self anyItemHit ];
}

/*===================================
    hitLogLevelSlider     
=====================================*/
- (IBAction)hitLogLevelSlider:(id)sender
{
    mLogLevelSliderState = [ sender intValue ];

    if ( mLogLevelSliderState == mSavedLogLevelSliderState  ) {
	mChangeValueFlag &= ~kChangeLogLevel;
    } else {
	mChangeValueFlag |= kChangeLogLevel;
    }

    [ self anyItemHit ];
}

/*===================================
    hitLogStyleSlider     
=====================================*/
- (IBAction)hitLogStyleSlider:(id)sender
{
    switch ( [sender intValue] ) {
	case 0:
	    [ mLogStyleSliderState setString : kWGStateLogStyle6K ];
	break;

	case 33:
	default:
	    [ mLogStyleSliderState setString : kWGStateLogStyle50K ];
	break;

	case 66:
	    [ mLogStyleSliderState setString : kWGStateLogStyle384K ];
	break;

	case 100:
	    [ mLogStyleSliderState setString : kWGStateLogStyle3M ];
	break;
    }
    
    if ( [ mLogStyleSliderState isEqualToString : mSavedLogStyleSliderState ] ) {
	mChangeValueFlag &= ~kChangeLogStyle;
    } else {
	mChangeValueFlag |= kChangeLogStyle;
    }

    [ self anyItemHit ];
}

/*===================================
    hitOutputLogFileCButton     
=====================================*/
- (IBAction)hitOutputLogFileCButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mOutputLogFileCButtonState = kWGStateButtonON;
    } else {
	mOutputLogFileCButtonState = kWGStateButtonOFF;
    }
    
    if ( mOutputLogFileCButtonState == mSavedOutputLogFileCButtonState  ) {
	mChangeValueFlag &= ~kChangeOutputLogFile;
    } else {
	mChangeValueFlag |= kChangeOutputLogFile;
    }

    [ self anyItemHit ];
}

/*===================================
    anyItemHit     
=====================================*/
- (void)anyItemHit
{
    if ( mChangeValueFlag ) [ WGPrefreanceInstance changeValue : self ];
    else [ WGPrefreanceInstance unchangeValue : self ];
}

/*===================================
    hitLogFileSaveLocationOpenButton     
=====================================*/
- (IBAction)hitLogFileSaveLocationOpenButton:(id)sender
{
    NSOpenPanel*	thePanel = [ NSOpenPanel openPanel ];
    
    [ thePanel setCanChooseDirectories : YES ];
    [ thePanel setCanChooseFiles : NO ];
    [ thePanel setAllowsMultipleSelection : NO ];
    [ thePanel beginSheetForDirectory : NSHomeDirectory()
				 file : nil
				types : nil
		       modalForWindow : [ NSApp keyWindow ]
			modalDelegate : self
		       didEndSelector : @selector( saveLogFileLocationOpenPanelDidEnd : returnCode : contextInfo : )
			  contextInfo : nil ];
	 
}

/*===================================
    saveLogFileLocationOpenPanelDidEnd hitSaveLocationOpenButtondidEndSheet     
=====================================*/
- (void)saveLogFileLocationOpenPanelDidEnd : (NSOpenPanel *)sheet returnCode : (int)returnCode contextInfo : (void *)contextInfo
{
    NSArray*	theFilesToOpen;
    NSString* 	theFileName;
    
    if ( returnCode == NSOKButton ) {
        theFilesToOpen = [ sheet filenames ];
	theFileName = [ theFilesToOpen objectAtIndex : 0 ];
	
	[ _l_LogFileOutputLocation setStringValue : theFileName ];
	[ self hitLogFileSaveLocationTextEdit : _l_LogFileOutputLocation ];
    }
}



@end
