#import "WGPreferenceOtherController.h"

@implementation WGPreferenceOtherController
/*===================================
     
=====================================*/
- (id)init
{
    self = [ super init ];
    
    mDontLookupDNSCButtonState = kWGStateButtonOFF;
    mOnlyCheakCButtonState = kWGStateButtonOFF;
    mUseFTPPassiveModeCButtonState = kWGStateButtonOFF;
    mUseProxyCButtonState = kWGStateButtonOFF;
    mProxyIPAdressState = [ [ NSMutableString alloc ] init ];
    mProxyPortState = [ [ NSMutableString alloc ] init ];
    mChangeValueFlag = 0;

    mSavedDontLookupDNSCButtonState = kWGStateButtonOFF;
    mSavedOnlyCheakCButtonState = kWGStateButtonOFF;
    mSavedUseFTPPassiveModeCButtonState = kWGStateButtonOFF;
    mSavedUseProxyCButtonState = kWGStateButtonOFF;
    mSavedProxyIPAdressState = [ [ NSMutableString alloc ] init ];
    mSavedProxyPortState = [ [ NSMutableString alloc ] init ];

    return self;
}

/*===================================
    dealloc 
=====================================*/
- (void)dealloc
{
    [ mProxyIPAdressState release ];
    [ mProxyPortState release ];
    [ mSavedProxyIPAdressState release ];
    [ mSavedProxyPortState release ];
    
    [ super dealloc ];
}

/*===================================
    GUI\̏ 
=====================================*/
- (void)initValuesWithDictionary : (NSMutableDictionary*)values
{
    mChangeValueFlag = 0;

    mSavedDontLookupDNSCButtonState = [ [ values objectForKey : kPreference_o_DNSLookUpKey ] boolValue ];
    mSavedOnlyCheakCButtonState = [ [ values objectForKey : kPreference_o_OnlyCheakKey ] boolValue ];
    mSavedUseFTPPassiveModeCButtonState = [ [ values objectForKey : kPreference_o_UsePassiveModeKey ] boolValue ];
    mSavedUseProxyCButtonState = [ [ values objectForKey : kPreference_o_UseProxyKey ] boolValue ];
    [ mSavedProxyIPAdressState setString : [ values objectForKey : kPreference_o_ProxyIPAdressKey ] ];
    [ mSavedProxyPortState setString : [ values objectForKey : kPreference_o_ProxyPortKey ] ];

    [ self setValuesWithDictionary : values ];
}

/*===================================
    GUIɐݒ肷  
=====================================*/
- (void)setValuesWithDictionary : values
{
    mDontLookupDNSCButtonState = [ [ values objectForKey : kPreference_o_DNSLookUpKey ] boolValue ];
    mOnlyCheakCButtonState = [ [ values objectForKey : kPreference_o_OnlyCheakKey ] boolValue ];
    mUseFTPPassiveModeCButtonState = [ [ values objectForKey : kPreference_o_UsePassiveModeKey ] boolValue ];
    mUseProxyCButtonState = [ [ values objectForKey : kPreference_o_UseProxyKey ] boolValue ];
    [ mProxyIPAdressState setString : [ values objectForKey : kPreference_o_ProxyIPAdressKey ] ];
    [ mProxyPortState setString : [ values objectForKey : kPreference_o_ProxyPortKey ] ];

    // DNSbNAbvȂ  
    if ( kWGStateButtonON == mDontLookupDNSCButtonState ) {
	[ _o_DontLookUpDNS setState : NSOnState ];
    } else {
	[ _o_DontLookUpDNS setState : NSOffState ];
    }
    // `FbNs  
    if ( kWGStateButtonON == mOnlyCheakCButtonState ) {
	[ _o_OnlyCheak setState : NSOnState ];
    } else {
	[ _o_OnlyCheak setState : NSOffState ];
    }
    // Ot@Cɏo͂  
    if ( kWGStateButtonON == mUseFTPPassiveModeCButtonState ) {
	[ _o_UseFtpPassiveMode setState : NSOnState ];
    } else {
	[ _o_UseFtpPassiveMode setState : NSOffState ];
    }
    // vNVg  
    if ( kWGStateButtonON == mUseProxyCButtonState ) {
	[ _o_UseProxy setState : NSOnState ];
    } else {
	[ _o_UseProxy setState : NSOffState ];
    }
    // vNVAhX  
    [ _o_ProxyServerAdress setStringValue : mSavedProxyIPAdressState ];
    // vNV|[g  
    [ _o_ProxyServerPort setStringValue : mSavedProxyPortState ];
}

/*===================================
    LZꂽ̃Zbg   
=====================================*/
- (void)resetValuesWithDictionary : (NSMutableDictionary*)values
{
    mChangeValueFlag = 0;
    [ self setValuesWithDictionary : values ];
} 

/*===================================
    ̐ݒԂ    
=====================================*/
- (NSDictionary*)dictionaryValues
{
    NSDictionary*	theReturn;
    theReturn = [ [ NSDictionary alloc ] initWithObjectsAndKeys :
		    [ NSNumber numberWithBool : mDontLookupDNSCButtonState ], kPreference_o_DNSLookUpKey,
		    [ NSNumber numberWithBool : mOnlyCheakCButtonState ], kPreference_o_OnlyCheakKey,
		    [ NSNumber numberWithBool : mUseFTPPassiveModeCButtonState ], kPreference_o_UsePassiveModeKey,
		    [ NSNumber numberWithBool : mUseProxyCButtonState ], kPreference_o_UseProxyKey,
		    mProxyIPAdressState, kPreference_o_ProxyIPAdressKey,
		    mProxyPortState, kPreference_o_ProxyPortKey,
		    kDefaultPreference_o_DontGetArrayValue, kPreference_o_DontGetArrayKey,	// ō쐬 
		    nil ];
    return theReturn;
}

/*===================================
    hitDontDownloadTypeAddButton     
=====================================*/
- (IBAction)hitDontDownloadTypeAddButton:(id)sender
{
}

/*===================================
    hitDontDownloadTypeDelButton     
=====================================*/
- (IBAction)hitDontDownloadTypeDelButton:(id)sender
{
}

/*===================================
    hitDontDownloadTypeModButton     
=====================================*/
- (IBAction)hitDontDownloadTypeModButton:(id)sender
{
}

/*===================================
    hitDontLookupDNSCButton     
=====================================*/
- (IBAction)hitDontLookupDNSCButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mDontLookupDNSCButtonState = kWGStateButtonON;
    } else {
	mDontLookupDNSCButtonState = kWGStateButtonOFF;
    }
    
    if ( mDontLookupDNSCButtonState == mSavedDontLookupDNSCButtonState  ) {
	mChangeValueFlag &= ~kChangeDontLookupDNS;
    } else {
	mChangeValueFlag |= kChangeDontLookupDNS;
    }

    [ self anyItemHit ];
}

/*===================================
    hitFTPUsePassiveModeRButton     
=====================================*/
- (IBAction)hitFTPUsePassiveModeRButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mUseFTPPassiveModeCButtonState = kWGStateButtonON;
    } else {
	mUseFTPPassiveModeCButtonState = kWGStateButtonOFF;
    }
    
    if ( mUseFTPPassiveModeCButtonState == mSavedUseFTPPassiveModeCButtonState  ) {
	mChangeValueFlag &= ~kChangeUseFTPPassiveMode;
    } else {
	mChangeValueFlag |= kChangeUseFTPPassiveMode;
    }

    [ self anyItemHit ];
}

/*===================================
    hitOnlyCheakCButton     
=====================================*/
- (IBAction)hitOnlyCheakCButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mOnlyCheakCButtonState = kWGStateButtonON;
    } else {
	mOnlyCheakCButtonState = kWGStateButtonOFF;
    }
    
    if ( mOnlyCheakCButtonState == mSavedOnlyCheakCButtonState  ) {
	mChangeValueFlag &= ~kChangeOnlyCheak;
    } else {
	mChangeValueFlag |= kChangeOnlyCheak;
    }

    [ self anyItemHit ];
}

/*===================================
    hitProxyIPAdressTextEdit     
=====================================*/
- (IBAction)hitProxyIPAdressTextEdit:(id)sender
{
    [ mProxyIPAdressState setString : [ sender stringValue ] ];

    if ( [ mProxyIPAdressState isEqualToString : mSavedProxyIPAdressState ] ) {
	mChangeValueFlag &= ~kChangeProxyIPAdress;
    } else {
	mChangeValueFlag |= kChangeProxyIPAdress;
    }

    [ self anyItemHit ];
}

/*===================================
    hitProxyPortTextEdit     
=====================================*/
- (IBAction)hitProxyPortTextEdit:(id)sender
{
    [ mProxyPortState setString : [ sender stringValue ] ];

    if ( [ mProxyPortState isEqualToString : mSavedProxyPortState ] ) {
	mChangeValueFlag &= ~kChangeProxyPort;
    } else {
	mChangeValueFlag |= kChangeProxyPort;
    }

    [ self anyItemHit ];
}

/*===================================
    hitUseProxyCButton     
=====================================*/
- (IBAction)hitUseProxyCButton:(id)sender
{
    if ( [ sender state] == NSOnState ) {
	mUseProxyCButtonState = kWGStateButtonON;
    } else {
	mUseProxyCButtonState = kWGStateButtonOFF;
    }
    
    if ( mProxyPortState == mSavedProxyPortState  ) {
	mChangeValueFlag &= ~kChangeProxyPort;
    } else {
	mChangeValueFlag |= kChangeProxyPort;
    }

    [ self anyItemHit ];
}

/*===================================
    anyItemHit     
=====================================*/
- (void)anyItemHit
{
    if ( mChangeValueFlag ) [ WGPrefreanceInstance changeValue : self ];
    else [ WGPrefreanceInstance unchangeValue : self ];
}
@end
