/*=============================================
    タイマー使わない方法があるようなので、
    作り直す必要あり。 
===========================================*/
#import "WGWetsCmdWrappar.h"

@implementation WGWetsCmdWrappar

/*===================================
    初期化 
=====================================*/
- (id)init
{
    [ super init ];

    mNowDownloading = NO;
    mTimer = nil;
    mTask = [ [ NSTask alloc ] init ];
    mPipe = [ NSPipe pipe ];
    [ mPipe retain ];
    mReadHandle = [ mPipe fileHandleForReading ];		// retainされているようだ！？ 
    
    [ [ NSNotificationCenter defaultCenter ] addObserver : self 
						selector : @selector( checkTerminationStatus : ) 
						    name : NSTaskDidTerminateNotification 
						  object : mTask ];

    return self;
}

/*===================================
    dealloc 
=====================================*/
 - (void)dealloc
{
    [ [ NSNotificationCenter defaultCenter ] removeObserver : self ];
    [ mPipe release ];
    [ mTask release ];
    [ mTimer invalidate ];
    [ mTimer release ];

    [ super dealloc ];
}

/*===================================
    ダウンロードスタート  
=====================================*/
- (BOOL)startDownload : (NSMutableArray*)inArgs
{
    if ( mNowDownloading ) return NO;		// あり得ないはず。 
    
    mNowDownloading = YES;

    mTimer = [ NSTimer scheduledTimerWithTimeInterval : kTimerInterval 
					       target : self 
					     selector : @selector( seeStdErr ) 
					     userInfo : nil
					      repeats : YES ];
    [ mTask setArguments : inArgs ];
    [ mTask setLaunchPath : kWgetCmdPathString ];
    [ mTask setStandardError : mPipe ];
    [ mTask setCurrentDirectoryPath : NSHomeDirectory() ];
    [ mTask launch] ;
    
    return YES;
}

/*===================================
    ダウンロードストップ   
=====================================*/
- (void)stopDownload
{
    [ mTimer invalidate ];
    [ mTask terminate ];
    [ mPipe release ];			// 仮にもう一度、releaseされても大丈夫のはず。 
    [ mTask release ];
    
    mPipe = nil;
    mTask = nil;
    mTimer = nil;
    mReadHandle = nil;
}

/*===================================
    標準エラーを見る    
=====================================*/
- (void)seeStdErr
{
    NSData*	theData = nil;
    NSString*	strErr;

    if ( ( theData = [ mReadHandle availableData ] ) && ( [ theData length ] ) ) {
	strErr  = [ NSString stringWithFormat : @"%s", [ theData bytes ] ];
	[ (WGWindowController*)mWindowCtlr getResponseWithString : strErr ];
    }
}

/*===================================
    mTaskのnotifier 
=====================================*/
- (void)checkTerminationStatus : (NSNotification *)inNotification
{
    int status;
    
    [ self seeStdErr ];		// log表示で、タイムラグを矯正 

    status = [ [ inNotification object ] terminationStatus ];
    [ (WGWindowController*)mWindowCtlr getResponseWithTerminationStatus : status ];
}

@end
